package com.qs.demo;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.GridView;
import android.widget.TextView;

import com.qs.adapter.TestInfoAdapter;
import com.qs.bean.TestInfo;
import com.qs.wiget.App;
import com.qs4g5501hdemo.R;

/**
 * 主界面
 * @author wsl
 *
 */
public class MainActivity extends Activity {

	private GridView mGridView = null;
	private List<TestInfo> testInfos = null;
	private TestInfoAdapter  mAdapter = null;
	private TextView textView2;


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_test);

		initViews();
		initData();
		setListener();
		//列表分3行
		mGridView.setNumColumns(3);

	}

	private void initData() {
		// TODO Auto-generated method stub

		testInfos = new ArrayList<TestInfo>();
		TestInfo  info = null;

		info = new TestInfo(getString(R.string.print),R.drawable.ic_printimage,-2);
		testInfos.add(info);

		info = new TestInfo(getString(R.string.ic_card),R.drawable.ic_psam,-7);
		testInfos.add(info);

		info = new TestInfo("NFC",R.drawable.ic_ic,-6);
		testInfos.add(info);


		mAdapter = new TestInfoAdapter(MainActivity.this, testInfos);
		mGridView.setAdapter(mAdapter);

	}

	private void initViews() {
		// TODO Auto-generated method stub

		mGridView = (GridView)this.findViewById(R.id.mGridView);

		textView2=(TextView) findViewById(R.id.textView2);

		textView2.setText("5501P 2022-12-26 V1.0");

	}

	private void setListener() {
		// TODO Auto-generated method stub
		mGridView.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view,
									int position, long id) {
				// TODO Auto-generated method stub
				TestInfo info = (TestInfo) parent.getAdapter().getItem(position);
				switch(info.getCmd()){
					case -2:
						//扫描和打印
						startActivity(new Intent(MainActivity.this, PrintActivity.class));
						break;
					case -6:
						//NFC
						startActivity(new Intent(MainActivity.this, NFCActivity.class));
						break;
					case -7:
						//IC卡
						App.isScan=false;
						startActivity(new Intent(MainActivity.this, ICResetActivity.class));
						break;
				}
			}
		});
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();

	}

	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		App.closeCommonApi();
		System.exit(0);
		super.onDestroy();
	}

}

