package com.qs.demo;

import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Environment;
import android.text.InputType;
import android.text.Selection;
import android.text.Spannable;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;
import android.widget.Toast;

import com.qs.wiget.App;
import com.qs4g5501hdemo.R;

public class PrintActivity extends Activity {

	private ScanBroadcastReceiver scanBroadcastReceiver;

	private EditText tv;

	String str_massage;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		App.isScan=true;

		initView();

		scanBroadcastReceiver = new ScanBroadcastReceiver();
		IntentFilter intentFilter = new IntentFilter();
		intentFilter.addAction("com.qs.scancode");
		this.registerReceiver(scanBroadcastReceiver, intentFilter);

	}

	/**
	 * 控件初始化以及按钮监听
	 */
	private void initView() {
		// TODO Auto-generated method stub
		tv = (EditText) findViewById(R.id.tv);

		// 扫描
		findViewById(R.id.btn_scan1).setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub

				App.openScan();

			}
		});

		// 打印文字
		findViewById(R.id.btn_printText).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View v) {
						// TODO Auto-generated method stub
						str_massage = tv.getText().toString();
						printeText(str_massage);
					}
				});

		// 打印一维码
		findViewById(R.id.btn_printBarcode).setOnClickListener(
				new OnClickListener() {
					@Override
					public void onClick(View v) {
						// TODO Auto-generated method stub
						printBarCode();
					}
				});

		// 打印二维码
		findViewById(R.id.btn_printQRcode).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View v) {
						// TODO Auto-generated method stub
						printQrCode();
//						showDialog_qr();
					}
				});

		// 保存内容
		findViewById(R.id.btn_save).setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				saveData();
			}
		});

		// 获取权限，在安卓6.0或者以上系统的机器上需要进行该操作，否则将会出现无法读写SD卡的情况
//		verifyStoragePermissions(this);
	}

	// 打印文字
	private void printeText(String str) {
		App.printText(1, 0, str + "\n");
	}

	// 打印条码
	private void printBarCode() {
		// 获取编辑框中的字符串
		str_massage = tv.getText().toString().trim();
		if (str_massage == null || str_massage.length() <= 0)
			return;

		// 判断当前字符能否生成条码
		if (str_massage.getBytes().length > str_massage.length()) {
			Toast.makeText(PrintActivity.this, "当前数据不能生成一维码",
					Toast.LENGTH_SHORT).show();
			return;
		}

		//打印3空行，控制图片前端空白
		App.send(new byte[]{0x0a,0x0a});

		App.printBarCode(0, 380, 100, str_massage);

		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		//走纸到下一标签页
		App.send(new byte[]{0x1d,0x0c});
	}

	// 打印二维码
	private void printQrCode() {
		// 获取编辑框中的字符串
		str_massage = tv.getText().toString().trim();
		if (str_massage == null || str_massage.length() <= 0)
			return;

		App.printQRCode(1, 250, 250,str_massage);

	}

	// 保存内容至SD卡
	private void saveData() {
		// 获取编辑框中的字符串
		str_massage = tv.getText().toString().trim();

		SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		//获取当前时间
		Date date = new Date(System.currentTimeMillis());
		// 读取已经保存的数据
		String str = readSDFile();
		// 数据保存
		saveDada2SD(str + "\n" + str_massage+"   "+simpleDateFormat.format(date));
	}

	/**
	 *
	 * 读取SD卡中文本文件
	 *
	 * @param fileName
	 *
	 * @return
	 */
	@SuppressWarnings("resource")
	public String readSDFile() {
		try {
			File file = new File("/mnt/sdcard/pro.txt");
			FileInputStream is = new FileInputStream(file);
			byte[] b = new byte[is.available()];
			is.read(b);
			String result = new String(b);
			System.out.println("读取成功：" + result);
			return result;
		} catch (Exception e) {
			e.printStackTrace();
			return "";
		}
	}

	// 保存至SD卡
	public void saveDada2SD(String sb) {
		String filePath = null;
		boolean hasSDCard = Environment.getExternalStorageState().equals(
				Environment.MEDIA_MOUNTED);
		if (hasSDCard) { // SD卡根目录的hello.text
			filePath = "/mnt/sdcard/pro.txt";
		}
		try {
			File file = new File(filePath);
			if (!file.exists()) {
				File dir = new File(file.getParent());
				dir.mkdirs();
				file.createNewFile();
			}
			FileOutputStream fileOut = null;
			BufferedOutputStream writer = null;
			OutputStreamWriter outputStreamWriter = null;
			BufferedWriter bufferedWriter = null;
			try {
				fileOut = new FileOutputStream(file);
				writer = new BufferedOutputStream(fileOut);
				outputStreamWriter = new OutputStreamWriter(writer, "UTF-8");
				bufferedWriter = new BufferedWriter(outputStreamWriter);
				bufferedWriter.write(new String(sb.toString()));
				bufferedWriter.close();
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		Toast.makeText(this, "保存成功，请到SD卡查看,文件名为pro.txt", Toast.LENGTH_SHORT)
				.show();
	}

//	// 检查读写权限
//	public void verifyStoragePermissions(Activity activity) {
//		try {
//			// 检测是否有写的权限
//			int permission = ActivityCompat.checkSelfPermission(activity,
//					"android.permission.WRITE_EXTERNAL_STORAGE");
//			if (permission != PackageManager.PERMISSION_GRANTED) {
//				// 没有写的权限，去申请写的权限，会弹出对话框
//				ActivityCompat.requestPermissions(activity,
//						PERMISSIONS_STORAGE, REQUEST_EXTERNAL_STORAGE);
//			}
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//	}

	class ScanBroadcastReceiver extends BroadcastReceiver {
		@Override
		public void onReceive(Context context, Intent intent) {
			// TODO Auto-generated method stub
			//获取扫描数据
			String text1 = intent.getExtras().getString("code");

			String str1 = tv.getText().toString();
			tv.setText(str1.trim()+"\n"+text1.trim());
			CharSequence text = tv.getText();
			if (text instanceof Spannable) {
				Spannable spanText = (Spannable) text;
				Selection.setSelection(spanText, text.length());
			}
		}
	}

	void showDialog_qr(){
		final EditText et = new EditText(PrintActivity.this);
		et.setInputType(InputType.TYPE_CLASS_NUMBER);
		et.setText("1");
		AlertDialog.Builder ab = new AlertDialog.Builder(
				PrintActivity.this);
		ab.setTitle("请输入打印二维码张数")
				.setView(et)
				.setPositiveButton("确认",
						new DialogInterface.OnClickListener() {
							@Override
							public void onClick(DialogInterface dialog,
												int which) {
								// TODO Auto-generated method stub

								String str=et.getText()
										.toString().trim();

								if(str.length()<=0){
									Toast.makeText(getApplicationContext(), "请输入打印张数", 0).show();
									return;
								}

								int a = Integer.valueOf(et.getText()
										.toString());

								for (int i = 0; i < a; i++) {
									printQrCode();
									try {
										Thread.sleep(2000);
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						});
		ab.create().show();
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		// 默认开启黑标
//		App.send(new byte[] { 0x1F, 0x1B, 0x1F, (byte) 0x80, 0x04,
//				0x05, 0x06, 0x44 });
		super.onResume();
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		Toast.makeText(getApplicationContext(), "关闭应用", Toast.LENGTH_SHORT).show();
		unregisterReceiver(scanBroadcastReceiver);
		App.closeCommonApi();
		System.exit(0);
		super.onDestroy();
	}

}
